#ifndef _IMINIPLAYER2_H_
#define _IMINIPLAYER2_H_

#include <windows.h>

class IPlayerControl
{
public:
	IPlayerControl(){};

	virtual ~IPlayerControl(){};
	
	virtual int					__cdecl SetWindowHandle(HWND destHandle) = 0;

	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl SetFileName(const char *filename) = 0;

	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl ShowSnapshot(double sec) = 0;

	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl Play() = 0;
	
	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl Stop() = 0;

	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl Pause() = 0;

	// return 0 - error
	//		  1 - OK
	virtual int					__cdecl Seek(double sec) = 0;

	// return current position in seconds
	virtual double				__cdecl GetCurrentPos() = 0;

	// return media length in seconds
	virtual double				__cdecl GetFileLen() = 0;

	// not yet implemented
	virtual int					__cdecl GetNumFilters() = 0;

	// not yet implemented
	virtual const char*			__cdecl GetFilterName(int index) = 0;

	// if control change size, call this method to update player size
	virtual void				__cdecl Resize() = 0;
};

/*
	NewPlayerControl
	DeletePlayerControl
*/

typedef IPlayerControl* (__cdecl * PFNNewPlayerControl		) ();
typedef void			(__cdecl * PFNDeletePlayerControl	) (IPlayerControl* p);


class LPlayerControl
{
public:
	LPlayerControl()
	{
		h=LoadLibrary("MiniPlayer2.dll");
		if (h == NULL) return;
		
		pfNewPlayerControl		= (PFNNewPlayerControl	 ) GetProcAddress(h, "NewPlayerControl");
		pfDeletePlayerControl	= (PFNDeletePlayerControl) GetProcAddress(h, "DeletePlayerControl");
	};

	~LPlayerControl()
	{
		if (h!=NULL)
			FreeLibrary(h);
		pfNewPlayerControl	  = NULL;
		pfDeletePlayerControl = NULL;
	}
		
	IPlayerControl* NewPlayerControl	()
	{
		if (pfNewPlayerControl!=NULL)
			return pfNewPlayerControl();
		else return 0;
	}

	void DeletePlayerControl (IPlayerControl* p)
	{
		if (pfDeletePlayerControl!=NULL)
			pfDeletePlayerControl(p);
	}
	
private:
	HMODULE h;
	PFNNewPlayerControl		pfNewPlayerControl;
	PFNDeletePlayerControl	pfDeletePlayerControl;
	
};

extern LPlayerControl g_LPlayerControl;

#endif

/*
1. ubaci u neki cpp:
#include "mini2.h"
LPlayerControl g_LPlayerControl;




2. u nekoj metodi u cpp.....

IPlayerControl *MyPlayer;

MyPlayer = g_LPlayerControl.NewPlayerControl();

MyPlayer->SetWindowHandle(neki handle);
MyPlayer->SetFilename("foo.mpg(avi)");
MyPlayer->Play();
....

MyPlayer->Stop();
g_LPlayerControl.DeletePlayerControl(MyPlayer);



*/